function [A, B, c] = compute_jacobian(f, x, u, dt)

% f(x1,u1) ~ c + A(x1-x) + B(u1-u)

nX = length(x);
nU = length(u);

x_eps = 0.01;
u_eps = 0.01;


for i=1:nX
	x_plus = x;
	x_plus(i) = x_plus(i) + x_eps;
	x1_plus = f(x_plus, u, dt);
	x_minus = x;
	x_minus(i) = x_minus(i) - x_eps;
	x1_minus = f(x_minus, u, dt);
	A(:,i) = (x1_plus - x1_minus) / (2*x_eps);
end

for i=1:nU
	u_plus = u;
	u_plus(i) = u_plus(i) + u_eps;
	x1_plus = f(x, u_plus, dt);
	u_minus = u;
	u_minus(i) = u_minus(i) - u_eps;
	x1_minus = f(x, u_minus, dt);
	B(:,i) = (x1_plus - x1_minus) / (2*u_eps);
end

c = f(x,u,dt);

